Unit KartyaUn;
(*
   A magyar krtya tpusa.

   Tpus TKartya:
        Asszocilt mveletek:
    Makk,Piros,Tok,Zold:TSzin
    VII,VIII,IX,X,Also,Felso,Kiraly,Asz:TFigura
    Kartya(TSzin,TFigura):TKartya
    KartyaSzin(TKartya):TSzin
    KartyaFigura(TKartya):TFigura
    String2Szin(Const sz:String):TSzin;
    Szin2String(Const sz:TSzin):String;
    Szin2Kod(TSzin):Egesz
    Figura2Kod(TFigura):Egesz
    KodbolSzin(Egesz):TSzin U {NemDef}
    KodbolFigura(Egesz):TFigura U {NemDef}
        Aximk:
    k:t:TKrtya
    s:TSzin
    f:TFigura
    ko:Egesz
   1. k=Kartya(s,f) => KartyaSzin(k)=s ES KartyaFigura(k)=f
   2. KodbolSzin(SzinbolKod(s))=s  ES KodbolSzin(Figura2Kod(f))=f  ES
      s=KodbolSzin(ko) ES s<>NemDef => SzinbolKod(s)=ko  ES
      f=KodbolFigura(ko) ES f<>NemDef => Figura2Kod(f)=ko
   3. SzinbolKod(Makk)=0 ES ... ES SzinbolKod(Zold)=3 ES
      Figura2Kod(Makk)=0 ES ... ES Figura2Kod(Asz)=7
   ......................................................
   ExportModul TKartya:
     Tpus
       TSzin,TFigura
     Konstans
       Makk,Piros,Tok,Zold:TSzin
       VII,VIII,IX,X,Also,Felso,Kiraly,Asz:TFigura
     Fggvny Kartya(Konstans s:TSzin,TFigura):TKartya
     Fggvny KartyaSzin(Konstans k:TKartya):TSzin
     Fggvny KartyaFigura(Konstans k:TKartya):TFigura
     Fggvny String2Szin(Konstans sz:String):TSzin;
     Fggvny Szin2String(Konstans sz:TSzin):String;
     Fggvny Szin2Kod(Konstans s:TSzin):Egesz
     Fggvny Figura2Kod(Konstans f:TFigura):Egesz
     Fggvny Kod2Szin(Konstans ko:Egesz):TSzin U {NemDef}
     Fggvny Kod2Figura(Konstans ko:Egesz):TFigura U {NemDef}
     Eljrs  BeKartya(Vltoz k:TKartya)
     Eljrs  KiKartya(Konstans k:TKartya)
     Fggvny HibasESzin(Vltoz s:TSzin):Logikai
     Fggvny HibasEFigura(Vltoz f:TFigura):Logikai
     Fggvny HibasEKartya(Vltoz k:TKartya):Logikai
   ExportModul vge.
   ......................................................
   Modul TKartya:
    Reprezentci
     Tpus
       TSzin < Import(SzinUnit)
       TFigura < Import(FiguUnit)
       TKartya=Rekord(szin:TSzin, figura:TFigura, hiba:Logikai)
    Implementci
     Fggvny Kartya(Konstans s:TSzin,TFigura):TKartya
      {Ef:
       Uf:}
       Vltoz
         k:TKartya
       k.szin:=s; k.figura:=f
       Kartya:=k
     Fggvny vge.

     Fggvny KartyaSzin(Konstans k:TKartya):TSzin
      {Ef: -
       Uf:}
       KartyaSzin:=k.szin
     Fggvny vge.

     Fggvny KartyaFigura(Konstans k:TKartya):TFigura
      {Ef: -
       Uf:}
       KartyaFigura:=k.figura
     Fggvny vge.

     Eljrs  Be(Konstans kerd:Szveg, Vltoz k:TKartya)
      {Ef: ...
       Uf: ...}
       Be: k [k beolvassa: Input=>SzvegblTKrtya=>k]
     Eljrs vge.

     Eljrs  Ki(Konstans k:TKartya)
      {Ef: -
       Uf: ...}
       Ki: k [k kirsa: TKrtyblSzveg(k)=>Output]
     Eljrs vge.

     Fggvny HibasEKartya(Vltoz k:TKartya):Logikai
      {Ef: -
       Uf: k.hiba     => HibasEKartya=Igaz ES k=TKartya(Makk,VII)
           nem k.hiba => HibasEKartya=Hamis }
       Ha k.hiba akkor  HibasEKartya:=Igaz; k:=TKartya(Makk,VII)
               klnben HibasEKartya:=Hamis
     Fggvny vge.

   Modul vge.
*)
 Interface

     Uses
       SzinUnit,FiguUnit;
     Type
       TKartya=Record szin:TSzin; figura:TFigura; hiba:Boolean End;
     Procedure Kartya(Const s:TSzin; Const f:TFigura; Var kartyaKi:TKartya);
     Function KartyaSzin(Const k:TKartya):TSzin;
     Function KartyaFigura(Const k:TKartya):TFigura;
     Procedure Be(Const kerd:String; Var k:TKartya);
      {Ef: ... SZIN + ',' FIGURA alakban
       Uf: ...}
     Procedure  Ki(Const szov:String; Const k:TKartya; Const uto:String);
      {Ef: -
       Uf: ...}
     Function HibasEKartya(Var k:TKartya):Boolean;
      {Ef: -
       Uf: k.hiba     => HibasEKartya=Igaz ES k=TKartya(Min'TSzin,Min'TFigura)
           nem k.hiba => HibasEKartya=Hamis}

 Implementation

    Uses
      {Newdelay,}Crt; {az AltRutin.inc kvnja meg}
    {$i AltRutin.inc}

     Procedure Kartya(Const s:TSzin; Const f:TFigura; Var kartyaKi:TKartya);
      {Ef:
       Uf:}
     Begin
       kartyaKi.szin:=s; kartyaKi.figura:=f
     End;

     Function KartyaSzin(Const k:TKartya):TSzin;
      {Ef: -
       Uf:}
     Begin
       KartyaSzin:=k.szin
     End;

     Function KartyaFigura(Const k:TKartya):TFigura;
      {Ef: -
       Uf:}
     Begin
       KartyaFigura:=k.figura
     End;

     Procedure  Be(Const kerd:String; Var k:TKartya);
      {Ef: ... SZIN + ',' FIGURA alakban
       Uf: ...}
        Var
          sk,ss,sf:String;
          s:TSzin; f:TFigura;
          hol:Integer;
      Begin {az Ef-et nem ellenrizzk}
        Write(kerd);
        (* egyszerbb lenne:
           SzinUnit.Be('',k.szin); FiguUnit.Be('',k.figura)
        *)
        Readln(sk); sk:=StringUpCase(sk);
        hol:=Pos(',',sk); ss:=Copy(sk,1,hol-1); sf:=Copy(sk,hol+1,Length(sk));
        {Szin-kdols:}
        k.szin:=String2Szin(ss);
        {Figura-kdols:}
        k.figura:=String2Figura(sf);
      End;{BeKartya}

     Procedure  Ki(Const szov:String; Const k:TKartya; Const uto:String);
      {Ef: -
       Uf: ...}
     Begin
       Write(szov);
       SzinUnit.Ki('',k.szin,''); FiguUnit.Ki(' ',k.figura,'');
       Write(uto);
     End;

     Function HibasEKartya(Var k:TKartya):Boolean;
      {Ef: -
       Uf: k.hiba     => HibasEKartya=Igaz ES k=TKartya(Min'TSzin,Min'TFigura)
           nem k.hiba => HibasEKartya=Hamis}
     Begin
       If k.hiba then
       Begin
         HibasEKartya:=True; k.szin:=Low(TSzin); k.figura:=Low(TFigura);
       End
         else
       Begin
         HibasEKartya:=False
       End
     End;

Begin
End.
